package POBS2;


//   POBS2:           
//       .    ,         ,
//      .         
//            . 
//          .


/*:     SILAB .    SILAB   KomisijaZaNabavke   (datumPonude).*/
class UpravaFakulteta   // Subject
{
  SILAB sil[]; // ConcreteSubjects
  int brObs; // broj observera

  UpravaFakulteta(){sil = new SILAB[2]; brObs = 0;}
  void Dodaj(SILAB sil1) {sil[brObs++] = sil1;}
  void Izbaci(){}

  void obavestiTimove()
   { for(int i=0; i<brObs;i++)
       sil[i].proveriDatum();
   }

   public static void main(String args[])
         {  UpravaFakulteta uf = new UpravaFakulteta();
            KomisijaZaNabavke kzn = new KomisijaZaNabavke(uf);
            JavaTimPonuda jat = new JavaTimPonuda(kzn);  
            uf.Dodaj(jat);
            VBTimPonuda vbt = new VBTimPonuda(kzn);
            uf.Dodaj(vbt);
            kzn.odrediDatum();
            kzn.obavestiUpravuFakulteta();
            }
}

/*:       SILAB . */
class KomisijaZaNabavke   // ConcreteSubject
{ UpravaFakulteta uf;
  KomisijaZaNabavke  (UpravaFakulteta uf1){uf=uf1;}
  String datumPonude;
  void odrediDatum(){datumPonude = "22-dec-2017";}
  String vratiDatum(){return datumPonude;}
  void obavestiUpravuFakulteta(){uf.obavestiTimove();}
}

/*:          (proveriDatum())   KomisijaZaNabavke. */
abstract class SILAB // Observer
{ KomisijaZaNabavke kzn;
  String datumPonude;
  SILAB(KomisijaZaNabavke kzn1) {kzn = kzn1;}
  abstract void proveriDatum();
}

/*:      KomisijaZaNabavke.            KomisijaZaNabavke. 
*/
class JavaTimPonuda extends SILAB // ConcreteObserver1
{ JavaTimPonuda(KomisijaZaNabavke kzn1){super(kzn1);}
  @Override
  void proveriDatum() { datumPonude = kzn.vratiDatum();
	                System.out.println("Java tim - Datum do kada treba poslati ponudu: " + datumPonude);}
}
class VBTimPonuda extends SILAB // ConcreteObserver2
{ VBTimPonuda(KomisijaZaNabavke kzn1){super(kzn1);}
  @Override
  void proveriDatum() { datumPonude = kzn.vratiDatum();
	                System.out.println("VB tim - Datum do kada treba poslati ponudu: " + datumPonude);}
}

